PROGRAM Turbine;

USES Dos, Crt;

   CONST TTMax = 1E30;
         TTMar =   30;
         nmax = 50;

   TYPE  TTTitle = String[37];
         TTValue = Array [ 0 .. 11 ] of Real;
         TTIndex = Array [ 0 .. 11 ] of LongInt;

   VAR   Ind: TTIndex;
         D : TTValue;
         TTNum, TTWth, TTDec, TTDel : Integer;
         Cnt, CnC, Tot : LongInt;
         TTTit, TTPro, TTPar, TTMsg: TTTitle;
         ch : Char;

VAR   si, co, x, y, m : ARRAY [ 1 .. nmax ] OF Double;
      p : ARRAY [ 1 .. nmax ] OF Integer;
      i, j, t, n, kmax, k, s : Integer;
      r, q, masa, phi, tx, ty, nx, ny, dt, dn : Double;
      list : Boolean;
      name : String[40];
      lst : text;

PROCEDURE SetCursor( n, m : integer );
VAR reg : Registers;
BEGIN
   WITH reg DO BEGIN Ch := n; Cl := m; Ah := 1 END;
   Intr($10,reg);
END;

PROCEDURE LocalOptimization;
LABEL 14;
BEGIN
   CnC := 0;
   IF list THEN writeln(lst,'Local optimization', Cnt:6);
   FOR i := n DOWNTO 2 DO BEGIN
      j := 1 + trunc(i*Random);
      t := p[i]; p[i] := p[j]; p[j] := t;
   END;
   tx := 0; ty := 0;
   FOR i := 1 TO n DO BEGIN
      j := p[i];
      tx := tx + m[j]*x[i]; ty := ty + m[j]*y[i];
   END;
   tx := tx/masa; ty := ty/masa;
   dt := sqrt(sqr(tx)+sqr(ty));
   IF list THEN FOR i := 1 TO n DO writeln(lst,i:5,p[i]:5,m[p[i]]:6:0);
   IF list THEN writeln(lst,tx:12:5,ty:12:5,dt:12:5);
   k := 0;
   WHILE true DO BEGIN
      FOR i := 2 TO n-1 DO FOR j := i+1 TO n DO BEGIN
         CnC := CnC + 1;
         q := r*(m[p[i]]-m[p[j]])/masa;
         nx := tx - q*(co[i]-co[j]);
         ny := ty - q*(si[i]-si[j]);
         dn := sqrt(sqr(nx)+sqr(ny));
         IF dn < dt THEN BEGIN
            IF list THEN writeln(lst,i:5,j:5,nx:12:5,ny:12:5,dn:12:5);
            tx := nx; ty := ny; dt := dn; k := 0;
            t := p[i]; p[i] := p[j]; p[j] := t;
         END ELSE BEGIN
            k := k + 1; IF k >= kmax THEN GOTO 14
         END;
      END;
   END;
14:
   IF list THEN writeln(lst,tx:12:5,ty:12:5,dt:12:5);
   tx := 0; ty := 0;
   FOR i := 1 TO n DO BEGIN
      j := p[i];
      tx := tx + m[j]*x[i]; ty := ty + m[j]*y[i];
   END;
   tx := tx/masa; ty := ty/masa;
   dt := sqrt(sqr(tx)+sqr(ty));
   IF list THEN writeln(lst,tx:12:5,ty:12:5,dt:12:5);
   IF (dt < 0.001) OR list THEN BEGIN
      writeln(lst); writeln(lst,cnt:8,tx:12:5,ty:12:5,dt:12:5);
      FOR i := 1 TO n DO writeln(lst,i:5,p[i]:5,m[p[i]]:6:0);
   END;
   Tot := Tot + CnC;
   IF (cnt MOD 100 = 0) OR list THEN writeln(lst,cnt:8, CnC:12, Tot:12);
END;

PROCEDURE TopTen(
   TTTit, TTPro, TTPar, TTMsg: TTTitle;
   VAR TTInd: TTIndex; VAR TTVal: TTValue;
   TTWth, TTDec, TTDel: Integer );
   VAR i : Integer;

   PROCEDURE TopTenForm(TTIni:Boolean);
      VAR i : Integer;
   BEGIN
      ClrScr;
      GoToXY(TTMar,1); write('ͻ');
      GoToXY(TTMar,2); write('    T O P   T E N    Ķ');
      GoToXY(TTMar,3); write('͹');
      GoToXY(TTMar,4); write('',TTPro); GoToXY(TTMar+38,4); write('');
      GoToXY(TTMar,5); write('',TTPar); GoToXY(TTMar+38,5); write('');
      GoToXY(TTMar,6); write('͹');
      IF TTIni THEN BEGIN
         FOR i := 1 TO 10 DO BEGIN
            TTInd[i] := 0; TTVal[i] := TTMax;
            GoToXY(TTMar,6+i); write('',i:3,' ');
            GoToXY(TTMar+18,6+i); write('');
            GoToXY(TTMar+38,6+i); write('');
         END;
         TTInd[11] := 0; TTVal[11] := TTMax; TTNum := 0;
      END ELSE FOR i := 1 TO 10 DO BEGIN
         GoToXY(TTMar,6+i); write('',i:3,' ');
         write(TTInd[i]:9,'  ', TTVal[i]:1+TTWth:TTDec);
         GoToXY(TTMar+38,6+i); write('');
      END;
      GoToXY(TTMar,17); write('Ķ');
      GoToXY(TTMar,18); write(''); GoToXY(TTMar+18,18); write('');
      GoToXY(TTMar+38,18); write('');
      GoToXY(TTMar,19); write('͹');
      GoToXY(TTMar,20); write('',TTMsg); GoToXY(TTMar+38,20); write('');
      GoToXY(TTMar,21); write('͹');
      GoToXY(TTMar,22); write('',' ESC   - stop   ');
      GoToXY(TTMar+38,22); write('');
      GoToXY(TTMar,23); write('',' SPACE - step   ');
      GoToXY(TTMar+38,23); write('');
      GoToXY(TTMar,24); write('ͼ');
   END;

   PROCEDURE TopTenInsert;
   BEGIN
      GoToXY(TTMar+8,18); write(TTInd[0]:8);
      GoToXY(TTMar+19,18); write(TTVal[0]:17:TTDec);
      IF TTNum < 11 THEN TTNum := TTNum + 1;
      i := TTNum;
      IF TTVal[0] < TTVal[TTNum] THEN
         WHILE TTVal[0] < TTVal[i-1] DO BEGIN
            TTVal[i] := TTVal[i-1]; TTInd[i] := TTInd[i-1];
            IF i < 11 THEN BEGIN
               GoToXY(TTMar+8,6+i); write(TTInd[i]:8);
               GoToXY(TTMar+19,6+i); write(TTVal[i]:17:TTDec)
            END;
            IF i > 0 THEN BEGIN
               HighVideo; GoToXY(TTMar+8,5+i); write(TTInd[0]:8);
               GoToXY(TTMar+19,5+i);
               write(TTVal[0]:9:TTDec,'        ');
               NormVideo
            END;
            i := i - 1; Delay(TTDel);
         END;
      IF i > 0 THEN BEGIN
         TTVal[i] := TTVal[0]; TTInd[i] := TTInd[0];
         IF i < 11 THEN BEGIN
            Delay(TTDel); GoToXY(TTMar+8,6+i); write(TTInd[0]:8);
            GoToXY(TTMar+19,6+i); write(TTVal[0]:17:TTDec)
         END
      END;
   END;

BEGIN
   ch := ' ';
   SetCursor(2,1);
   TopTenForm(True);
   REPEAT
      Cnt := Cnt + 1; LocalOptimization;
      Ind[0] := Cnt; D[0] := dt;
      TopTenInsert;
      IF KeyPressed THEN ch := ReadKey;
      IF ch = ' ' THEN BEGIN
         REPEAT UNTIL KeyPressed; ch := ReadKey;
      END;
   UNTIL ch = Chr(27);
   Setcursor(11,12); ClrScr;
END;

PROCEDURE PrintTopTen;
   VAR i : Integer;
BEGIN
   writeln(lst,chr(12));
   writeln(lst,'ͻ');
   writeln(lst,'    T O P   T E N    Ķ');
   writeln(lst,'͹');
   writeln(lst,'',TTPro:37,                         '');
   writeln(lst,'',TTPar:37,                         '');
   writeln(lst,'͹');
   FOR i := 1 TO 10 DO BEGIN
      write(lst,'',i:3,' ');
      write(lst,Ind[i]:10,'  ', D[i]:17:TTDec);
      writeln(lst,'  ');
   END;
   writeln(lst,'Ķ');
   writeln(lst,'',Ind[0]:15,  '  ',D[0]:17:TTDec,'  ');
   writeln(lst,'͹');
   writeln(lst,'',TTMsg:37,                         '');
   writeln(lst,'ͼ');
END;

BEGIN
   ClrScr;
   TTPro := ' Local optimization - examples       ';
   TTMsg := ' (c)1992 Vladimir Batagelj           ';
   TTPar := ' Turbine balancing problem           ';
   GoToXY(20,6); write(TTPro);
   GoToXY(20,7); write(TTPar);
   GoToXY(20,8); write(TTMsg);
   GoToXY(20,12); write('number of blades = '); readln(n);
   GoToXY(20,14); write('list file        = '); readln(name);
   Assign(lst,name); Rewrite(lst);
   writeln(lst,'Local optimization ');
   writeln(lst,'number of blades = ',n:5);
   writeln(lst,'list file        = ',name);
   writeln(lst);
   r := 1000; list := true;
   kmax := n*(n-1) DIV 2; tx := 0; ty := 0; masa := 0;
   FOR i := 1 TO n DO BEGIN
      p[i] := i; phi := 2*(i-1)*Pi/n;
      si[i] := sin(phi); co[i] := cos(phi);
      x[i] := r*co[i]; y[i] := r*si[i];
      m[i] := i; masa := masa + m[i];
      tx := tx + m[i]*x[i]; ty := ty + m[i]*y[i];
   END;
   tx := tx/masa; ty := ty/masa;
   dt := sqrt(sqr(tx)+sqr(ty));
   IF list THEN writeln(lst,tx:12:5,ty:12:5,dt:12:5);
   Randomize;
   Cnt := 0; Tot := 0;
   TTWth := 8; TTDec:= 4; TTDel := 500;
   TopTen( TTTit, TTPro, TTPar, TTMsg, Ind, D, TTWth, TTDec, TTDel );
   GoToXY(30,12); write('K O N E C');
   readln; PrintTopTen;
   Close(lst);
END.
